package programming.parttwo;

/** Implementation of the Sokoban game
 *  @author Manuel Pereira
 *  @author Juan Gomez Romero
 * 
 *  COMPLETE THIS CLASS! */

public class MySokoban extends Sokoban {
	private static final long serialVersionUID = 1L;

	/* Board definition */
	/** Cell types */
	public enum Cell {EMPTY, BOX, PLAYER, WALL, STORAGE, STORED_BOX, PLAYER_AT_STORAGE};
		
	/** Number of rows (y-coordinate) */
	public static final int ROWS = 11;
	/** Number of cols (x-coordinate) */
	public static final int COLS = 19;
	
	/** Number of moves */
    private int moves;

    /** Main method */
	public static void main(String [] args) {
    	new MySokoban();
    }

    //-------------------------------------------------------------------- 
	/** Constructor */
	public MySokoban() {
		super(ROWS, COLS);
	}
	
    //--------------------------------------------------------------------
	/** Process key pressed on the game window 
	 *  Current implementation:
	 *  	q:          ends the game
	 *  	other keys: moves is updated 
	 *  @param      key Character pressed 
	 *  @deprecated This method must be implemented by the students */
	@Override
    public void processKey(char key) {
		char k = Character.toLowerCase(key);
		
        switch (k) {
            case 'q':            
                /* close frame, end program */
            	this.dispose();                
                break;            
            default:
                /* update moves */
            	setMoves(getMoves() + 10);
            	break;
        }
    }

    /** Get cell value
     *  @param row Board row
     *  @param col Board column
     *  @returns Cell  value at (row, col)
     *  @deprecated This method must be implemented by the students */ 
	@Override
    public Cell getCellFromBoard(int row, int col) {
		return getRandomCell();  // no real board is created  	
    }
    
    /** Generate random cell from available types 
     *  @returns Random cell */
    private Cell getRandomCell() {
        int index = (int)(Math.random() * Cell.values().length);
        return Cell.values()[index];        
    }
    
    /** Set moves attribute 
     *  @param moves New moves number */
    public void setMoves(int moves) {
        this.moves = moves;
    }
    
    /** Get moves attribute 
     *  @returns Moves value */
    public int getMoves() {
        return this.moves;
    }

}